From a11f05fc1091fce6a91bcb92658708ae081bf643 Mon Sep 17 00:00:00 2001
From: nerdopolis <bluescreen_avenger@verizon.net>
Date: Tue, 20 Feb 2024 20:04:30 -0500
Subject: [PATCH 03/14] Conditionalize more VT related calls

---
 src/daemon/Display.cpp | 19 ++++++++++++++-----
 src/daemon/Display.h   |  2 +-
 2 files changed, 15 insertions(+), 6 deletions(-)

diff --git a/src/daemon/Display.cpp b/src/daemon/Display.cpp
index 4014e0d..1a0a369 100644
--- a/src/daemon/Display.cpp
+++ b/src/daemon/Display.cpp
@@ -116,16 +116,22 @@ namespace SDDM {
         // Create display server
         switch (m_displayServerType) {
         case X11DisplayServerType:
-            m_terminalId = VirtualTerminal::setUpNewVt();
+            if (seat()->canTTY()) {
+                m_terminalId = VirtualTerminal::setUpNewVt();
+            }
             m_displayServer = new XorgDisplayServer(this);
             break;
         case X11UserDisplayServerType:
-            m_terminalId = fetchAvailableVt();
+            if (seat()->canTTY()) {
+                m_terminalId = fetchAvailableVt();
+            }
             m_displayServer = new XorgUserDisplayServer(this);
             m_greeter->setDisplayServerCommand(XorgUserDisplayServer::command(this));
             break;
         case WaylandDisplayServerType:
-            m_terminalId = fetchAvailableVt();
+            if (seat()->canTTY()) {
+                m_terminalId = fetchAvailableVt();
+            }
             m_displayServer = new WaylandDisplayServer(this);
             m_greeter->setDisplayServerCommand(mainConfig.Wayland.CompositorCommand.get());
             break;
@@ -421,7 +427,9 @@ namespace SDDM {
         m_sessionTerminalId = m_terminalId;
         if ((session.type() == Session::WaylandSession && m_displayServerType == X11DisplayServerType) || (m_greeter->isRunning() && m_displayServerType != X11DisplayServerType)) {
             // Create a new VT when we need to have another compositor running
-            m_sessionTerminalId = VirtualTerminal::setUpNewVt();
+            if (seat()->canTTY()) {
+                m_sessionTerminalId = VirtualTerminal::setUpNewVt();
+            }
         }
 
         // some information
@@ -439,7 +447,8 @@ namespace SDDM {
         env.insert(QStringLiteral("XDG_SESSION_CLASS"), QStringLiteral("user"));
         env.insert(QStringLiteral("XDG_SESSION_TYPE"), session.xdgSessionType());
         env.insert(QStringLiteral("XDG_SEAT"), seat()->name());
-        env.insert(QStringLiteral("XDG_VTNR"), QString::number(m_sessionTerminalId));
+        if (m_sessionTerminalId > 0)
+            env.insert(QStringLiteral("XDG_VTNR"), QString::number(m_sessionTerminalId));
 #ifdef HAVE_SYSTEMD
         env.insert(QStringLiteral("XDG_SESSION_DESKTOP"), session.desktopNames());
 #endif
diff --git a/src/daemon/Display.h b/src/daemon/Display.h
index 98ca006..a70671a 100644
--- a/src/daemon/Display.h
+++ b/src/daemon/Display.h
@@ -97,7 +97,7 @@ namespace SDDM {
         bool m_relogin { true };
         bool m_started { false };
 
-        int m_terminalId = 0;
+        int m_terminalId = -1;
         int m_sessionTerminalId = 0;
 
         QString m_passPhrase;
-- 
2.41.0

